



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Python中__init__方法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Python中__init__方法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-27 02:33:52 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>&nbsp;</div>
<div>
<div>
<p><strong>注意1</strong>、__init__并不相当于C#中的构造函数，执行它的时候，<strong>实例已构造</strong>出来了。</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
</td>
<td>
<div>
<div><code>class</code>&nbsp;<code>A(</code><code>object</code><code>):</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>def</code>&nbsp;<code>__init__(</code><code>self</code><code>,name):</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>self</code><code>.name</code><code>=</code><code>name</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>def</code>&nbsp;<code>getName(</code><code>self</code><code>):</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>'A '</code><code>+</code><code>self</code><code>.name</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>当我们执行</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
</td>
<td>
<div>
<div><code>a</code><code>=</code><code>A(</code><code>'hello'</code><code>)</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>时，可以理解为</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
</td>
<td>
<div>
<div><code>a</code><code>=</code><code>object</code><code>.__new__(A)</code></div>
<div><code>A.__init__(a,</code><code>'hello'</code><code>)</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>即__init__作用是初始化已实例化后的对象。</p>
<p><strong>注意2</strong>、子类可以<strong>不重写</strong>__init__，实例化子类时，<strong>会自动调用</strong>超类中已定义的__init__</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
</td>
<td>
<div>
<div><code>class</code>&nbsp;<code>B(A):</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>def</code>&nbsp;<code>getName(</code><code>self</code><code>):</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>'B '</code><code>+</code><code>self</code><code>.name</code></div>
<div>&nbsp;</div>
<div><code>if</code>&nbsp;<code>__name__</code><code>=</code><code>=</code><code>'__main__'</code><code>:</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>b</code><code>=</code><code>B(</code><code>'hello'</code><code>)</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>print</code>&nbsp;<code>b.getName()</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>但如果<strong>重写了</strong>__init__，实例化子类时，则<strong>不会隐式的再去调用</strong>超类中已定义的__init__</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
<div>9</div>
</td>
<td>
<div>
<div><code>class</code>&nbsp;<code>C(A):</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>def</code>&nbsp;<code>__init__(</code><code>self</code><code>):</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>pass</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>def</code>&nbsp;<code>getName(</code><code>self</code><code>):</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>'C '</code><code>+</code><code>self</code><code>.name</code></div>
<div>&nbsp;</div>
<div><code>if</code>&nbsp;<code>__name__</code><code>=</code><code>=</code><code>'__main__'</code><code>:</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>c</code><code>=</code><code>C()</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>print</code>&nbsp;<code>c.getName()</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>则会报"AttributeError: 'C' object has no attribute 'name'&rdquo;错误，所以<strong>如果重写了__init__，为了能使用或扩展超类中的行为，最好显式的调用超类的__init__方法</strong></p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
<div>9</div>
</td>
<td>
<div>
<div><code>class</code>&nbsp;<code>C(A):</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>def</code>&nbsp;<code>__init__(</code><code>self</code><code>,name):</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>super</code><code>(C,</code><code>self</code><code>).__init__(name)</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>def</code>&nbsp;<code>getName(</code><code>self</code><code>):</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>'C '</code><code>+</code><code>self</code><code>.name</code></div>
<div>&nbsp;</div>
<div><code>if</code>&nbsp;<code>__name__</code><code>=</code><code>=</code><code>'__main__'</code><code>:</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>c</code><code>=</code><code>C(</code><code>'hello'</code><code>)&nbsp;&nbsp;&nbsp; </code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>print</code>&nbsp;<code>c.getName()</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zexo38.html">Kinect V2 基础教程之彩色图像</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jgxve9.html">tyvj2018 小猫爬山</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxno0ed8.html">Out of resources when opening file 错误解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmvvv19.html">Ensemble learning（集成学习）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnrok6q.html">TabControl控件的美化</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1l34n9.html">用js实现跳转提示页面</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojk12eq.html">基于visual Studio2013解决C语言竞赛题之1087数字变换</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljlmxx9.html">浅谈javascript中的call&lpar;&rpar;和apply&lpar;&rpar;方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j2zml8.html">lucene全文搜索之一：lucene的主要功能和基本结构（基于lucene5&period;5&period;3）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjw33r8.html">Spark Streaming 调优指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/9genwd08.html">Junit4 之 Assert 静态方法介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/90ry2zj9.html">unicode 与 utf-8 编码概念及区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllvxj6q.html">&lbrack;js&rsqb;js中事件的3要素</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2rnrrq.html">python print格式化输出。</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyzmo19.html">tp框架  php ajax 登陆</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zym3739.html">作用域的一些说明&comma;static关键词</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rg4668.html">dom操作------创建节点&sol;插入节点</a>
		</li>
						<li><a href="https://www.batexi.com/a/953k2l68.html">查找mysql的my&period;cnf位置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8odnjmxq.html">windows平台mongoDB安装配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8odnvg5q.html">Winter-2-STL-A Argus 解题报告及测试数据</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9j223g8.html">Xcode添加代码块</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7gdrxq.html">CSS中的text-overflow&colon;clip&vert;ellipsis的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7g2vkq.html">数论 UVALive  2911</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdzrg09.html">C&num;的提交表单方式主要有两种WebClient与HttpWebRequest</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96yz2j8.html">UVa 221城市正视图（离散化）</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p36zkq.html">fastdfs-nginx扩展模块源码分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwry2z9.html">tengine&plus;tomcat配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p35ldq.html">内网透过公网nginx和vpn实现微信接口调试</a>
			</li>
						<li><a href="https://www.batexi.com/a/49g5vml8.html">ios 利用airprint实现无线打印（配合普通打印机）</a>
			</li>
						<li><a href="https://www.batexi.com/a/390pgo38.html">&lbrack;系统开发&rsqb; Python 实现的 Bind 智能 DNS Web 管理系统</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
